+++
title = 'IPv6 Adventures'
date = 2024-10-23T09:27:29+03:00
draft = false
+++

Today's story starts in a similar vein as to the last one. While waiting for a train, I stumbled across a provider which offered extremely cheap hosting, and severely undercut Gullo. Their name is [C-SERVERS](https://c-servers.co.uk/) and they seem to be reselling Hetzner, just like Gullo, but they give you more ram, at the cost of not giving you any IPv4 ports, at least as far as I can tell. So I bought one of their NanoVPS servers. Then, I hit my first roadblock... I can't SSH!
Unfortunately, due to my ISP being stupid, enabling IPv6 on our home router would do more harm than good, so as a temporary measure, I decided to use [tunnelbroker](https://tunnelbroker.net), which gave me a free IPv6 address. And now I can SSH!

After I got in, I decided that I can host a Discord bot for some of my friends, since that doesn't require a public IP. Yes yes I know what you're going to say "b-but don't you hate discord??" yes I do but unfortunately 70% of my friends aren't smart enough to use IRC or any alternative. 

My prefered mode of deployment is Docker, but then I hit my second roadblock... I can't update!

Debian's repositories have IPv6 support, and the VPS came with NAT64, but apparently, the ruby image I wanted to use, which is based on Debian, couldn't update. I bashed my head against the wall trying to figure out how I could update it, but I gave up running it in Docker. So I decided to do it the old fashioned way. I setup an user, and then when I was getting an up to date copy of my bot's source code from my git server, I hit my third roadblock: I can't clone!

Looks like I didn't have IPv6 enabled on the VPS hosting my git forge. Oops! It didn't take long to setup, but now I can rest easy at night knowing IPv6 chads can access my site directly.

After a bit of tinkering with rbenv and making a swapfile, I finally got Ruby rolling, and I finally got Jon back up and running! Yay!

I wouldn't say IPv6 is bad, it's the future, but I do consider it still got a long long long way to go. IPv4 isn't going anytime soon, but if you go on https://www.google.com/intl/en/ipv6/statistics.html, you'll see that IPv6 adoption is steadily growing, so you should probably stop putting off setting up IPv6. I encourage you to do so, [you'll be more up to date than Discord if you do that](https://support.discord.com/hc/en-us/community/posts/360047840052-Add-IPv6-support).
